package thehippomaster.animationapi;

import net.minecraft.entity.Entity;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.simpleimpl.SimpleNetworkWrapper;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.relauncher.Side;
import thehippomaster.animationapi.anim.IAnimatedEntity;
import thehippomaster.animationapi.common.CommonProxy;
import thehippomaster.animationapi.packet.PacketAnim;
import thehippomaster.animationapi.util.ModReference;

@Mod(modid = ModReference.MOD_ID, name = ModReference.MOD_NAME, version = ModReference.VERSION)
public class AnimationAPI
{
    // Instance
    @Mod.Instance(ModReference.MOD_ID)
    public static AnimationAPI INSTANCE;

    // Proxy
    @SidedProxy(clientSide = "thehippomaster.animationapi.client.ClientProxy", serverSide = "thehippomaster.animationapi.common.CommonProxy")

    public static CommonProxy proxy;
    public static SimpleNetworkWrapper wrapper;
    public static final String[] fTimer = new String[]{"field_71428_T", "S", "timer"};

    /**
     * Run before anything else. <s>Read your config, create blocks, items, etc, and register them with the GameRegistry</s>
     *
     * @see {@link net.minecraftforge.common.ForgeModContainer#preInit(FMLPreInitializationEvent) ForgeModContainer.preInit}
     */
    @Mod.EventHandler
    public void preinit(FMLPreInitializationEvent event) {
        System.out.println(ModReference.MOD_ID + ":preInit");
    }

    /**
     * Do your mod setup. Build whatever data structures you care about. Register recipes, send FMLInterModComms messages to other mods.
     */
    @Mod.EventHandler
    public void init(FMLInitializationEvent event) {
        System.out.println(ModReference.MOD_ID + ":init");
        wrapper = NetworkRegistry.INSTANCE.newSimpleChannel("animationapi");
        wrapper.registerMessage(PacketAnim.Handler.class, PacketAnim.class, 0, Side.CLIENT);
    }

    /**
     * Mod compatibility, or anything which depends on other mods’ init phases being finished.
     *
     * @see {@link net.minecraftforge.common.ForgeModContainer#postInit(FMLPostInitializationEvent) ForgeModContainer.postInit}
     */
    @Mod.EventHandler
    public void postinit(FMLPostInitializationEvent event) {
        proxy.initTimer();
    }

    /**
     * Forge will automatically look up and bind blocks to the fields in this class
     * based on their registry name.
     */
    @GameRegistry.ObjectHolder(ModReference.MOD_ID)
    public static class Blocks {
      /*
          public static final MySpecialBlock mySpecialBlock = null; // placeholder for special block below
      */
    }

    /**
     * Forge will automatically look up and bind items to the fields in this class
     * based on their registry name.
     */
    @GameRegistry.ObjectHolder(ModReference.MOD_ID)
    public static class Items {
      /*
          public static final ItemBlock mySpecialBlock = null; // itemblock for the block above
          public static final MySpecialItem mySpecialItem = null; // placeholder for special item below
      */
    }

    public static boolean isClient() {
        return FMLCommonHandler.instance().getSide().isClient();
    }

    public static boolean isEffectiveClient() {
        return FMLCommonHandler.instance().getEffectiveSide().isClient();
    }

    public static void sendAnimPacket(IAnimatedEntity entity, int animID) {
        if (!isEffectiveClient()) {
            entity.setAnimID(animID);
            wrapper.sendToAll(new PacketAnim((byte)animID, ((Entity)entity).func_145782_y()));
        }
    }
}
