package thehippomaster.animationapi.client.model.wavefront;

import net.minecraft.client.Minecraft;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.opengl.GL11;
import thehippomaster.animationapi.util.Color;

import java.util.ArrayList;

public class FaceGroup
{
  public String mtlName;
  public ResourceLocation resource;
  public ArrayList<Face> faces;
  public boolean listReady;
  public int glList;
  public Color color;
  
  public FaceGroup()
  {
    this.faces = new ArrayList();
    this.listReady = false;
  }
  
  public void bindTexture()
  {
    if (this.resource != null) {
      Minecraft.func_71410_x().field_71446_o.func_110577_a(this.resource);
    }
  }
  
  public void draw()
  {
    if (this.resource != null)
    {
      bindTexture();
      drawNoBind();
    }
    else
    {
      GL11.glDisable(3553);
      drawNoBind();
      GL11.glEnable(3553);
    }
  }
  
  public void drawNoBind()
  {
    if (!this.listReady)
    {
      this.listReady = true;
      GL11.glNewList(this.glList = GL11.glGenLists(1), 4864);
      drawVertex();
      GL11.glEndList();
    }
    GL11.glCallList(this.glList);
  }
  
  private void drawVertex()
  {
    int mode = 0;
    for (Face f : this.faces)
    {
      if (f.vertexNbr != mode)
      {
        if (mode != 0) {
          GL11.glEnd();
        }
        switch (f.vertexNbr)
        {
        case 3: 
          GL11.glBegin(4);
          break;
        case 4: 
          GL11.glBegin(7);
          break;
        case 6: 
          GL11.glBegin(5);
          break;
        case 8: 
          GL11.glBegin(5);
        }
        mode = f.vertexNbr;
      }
      if (this.color != null) {
        GL11.glColor3f(this.color.r, this.color.g, this.color.b);
      }
      GL11.glNormal3f(f.normal.x, f.normal.y, f.normal.z);
      for (int idx = 0; idx < mode; idx++)
      {
        if (f.uv[idx] != null) {
          GL11.glTexCoord2f(f.uv[idx].getU(), f.uv[idx].getV());
        }
        GL11.glVertex3f(f.vertex[idx].x, f.vertex[idx].y, f.vertex[idx].z);
      }
    }
    if (mode != 0) {
      GL11.glEnd();
    }
  }
}
